/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/

#line 1 "cmdline.opt"
/* This file is part of Grot.  -*- c -*-
   Copyright (C) 2009 Sergey Poznyakoff

   Grot is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   Grot is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with grot.  If not, see <http://www.gnu.org/licenses/>. */

#include "grot.h"
#include <getopt.h>

#define gettext(s) s
#define _(s) gettext(s)
#define N_(s) s

char *grot_host;
char *grot_password;
int password_option;
unsigned grot_port;
char *grot_socket;
char *grot_user;
int verbose;
int dry_run_option;
int flush_logs_option = 1;
size_t keep_count;

#line 35 "cmdline.opt"

#line 35
void print_help(void);
#line 35
void print_usage(void);
#line 101 "cmdline.opt"

#line 101
/* Option codes */
#line 101
enum {
#line 101
	_OPTION_INIT=255,
#line 101
	#line 86 "cmdline.opt"

#line 86
	OPTION_NO_FLUSH,	
#line 101 "cmdline.opt"

#line 101
	OPTION_USAGE,	
#line 101 "cmdline.opt"

#line 101
	OPTION_VERSION,	

#line 101 "cmdline.opt"
	MAX_OPTION
#line 101
};
#line 101
static struct option long_options[] = {
#line 101
	#line 38 "cmdline.opt"

#line 38
	{ "host", optional_argument, 0, 'H' },
#line 44 "cmdline.opt"

#line 44
	{ "password", optional_argument, 0, 'p' },
#line 51 "cmdline.opt"

#line 51
	{ "port", required_argument, 0, 'P' },
#line 60 "cmdline.opt"

#line 60
	{ "socket", required_argument, 0, 'S' },
#line 67 "cmdline.opt"

#line 67
	{ "user", required_argument, 0, 'u' },
#line 73 "cmdline.opt"

#line 73
	{ "verbose", no_argument, 0, 'v' },
#line 79 "cmdline.opt"

#line 79
	{ "dry-run", no_argument, 0, 'n' },
#line 86 "cmdline.opt"

#line 86
	{ "no-flush", no_argument, 0, OPTION_NO_FLUSH },
#line 92 "cmdline.opt"

#line 92
	{ "keep", required_argument, 0, 'k' },
#line 101 "cmdline.opt"

#line 101
	{ "help", no_argument, 0, 'h' },
#line 101 "cmdline.opt"

#line 101
	{ "usage", no_argument, 0, OPTION_USAGE },
#line 101 "cmdline.opt"

#line 101
	{ "version", no_argument, 0, OPTION_VERSION },

#line 101 "cmdline.opt"
	{0, 0, 0, 0}
#line 101
};
#line 101
static struct opthelp {
#line 101
        const char *opt;
#line 101
        const char *arg;
#line 101
        int is_optional;
#line 101
        const char *descr;
#line 101
} opthelp[] = {
#line 101
	#line 40 "cmdline.opt"

#line 40
	{ "-H, --host", N_("NAME"), 1, N_("server host") },
#line 46 "cmdline.opt"

#line 46
	{ "-p, --password", N_("PASS"), 1, N_("MySQL user password") },
#line 53 "cmdline.opt"

#line 53
	{ "-P, --port", N_("NUMBER"), 0, N_("port number") },
#line 62 "cmdline.opt"

#line 62
	{ "-S, --socket", N_("STRING"), 0, N_("socket file name") },
#line 69 "cmdline.opt"

#line 69
	{ "-u, --user", N_("NAME"), 0, N_("user name") },
#line 75 "cmdline.opt"

#line 75
	{ "-v, --verbose", NULL, 0, N_("increase verbosity level") },
#line 81 "cmdline.opt"

#line 81
	{ "-n, --dry-run", NULL, 0, N_("do not actually rotate the logs") },
#line 88 "cmdline.opt"

#line 88
	{ "--no-flush", NULL, 0, N_("do not flush logs after rotating") },
#line 94 "cmdline.opt"

#line 94
	{ "-k, --keep", N_("NUMBER"), 0, N_("keep NUMBER of files before oldest") },
#line 101 "cmdline.opt"

#line 101
	{ NULL, NULL, 0, N_("Other options") },	
#line 101 "cmdline.opt"

#line 101
	{ "-h, --help", NULL, 0, N_("Give this help list") },
#line 101 "cmdline.opt"

#line 101
	{ "--usage", NULL, 0, N_("Give a short usage message") },
#line 101 "cmdline.opt"

#line 101
	{ "--version", NULL, 0, N_("Print program version") },

#line 101 "cmdline.opt"
};
#line 35 "cmdline.opt"

#line 35
#include <ctype.h>
#line 35
const char *program_version = "grot" " (" PACKAGE_STRING ")";
#line 35
static char doc[] = N_("Gray's Rotation Tool for MySQL binary logs");
#line 35
static char args_doc[] = N_("");
#line 35
const char *program_bug_address = "<" PACKAGE_BUGREPORT ">";
#line 35
		    
#line 35
#define DESCRCOLUMN 30
#line 35
#define RMARGIN 79
#line 35
#define GROUPCOLUMN 2
#line 35
#define USAGECOLUMN 13
#line 35
		    
#line 35
static void
#line 35
indent (size_t start, size_t col)
#line 35
{
#line 35
  for (; start < col; start++)
#line 35
    putchar (' ');
#line 35
}
#line 35
		    
#line 35
static void
#line 35
print_option_descr (const char *descr, size_t lmargin, size_t rmargin)
#line 35
{
#line 35
  while (*descr)
#line 35
    {
#line 35
      size_t s = 0;
#line 35
      size_t i;
#line 35
      size_t width = rmargin - lmargin;
#line 35

#line 35
      for (i = 0; ; i++)
#line 35
	{
#line 35
	  if (descr[i] == 0 || isspace (descr[i]))
#line 35
	    {
#line 35
	      if (i > width)
#line 35
		break;
#line 35
	      s = i;
#line 35
	      if (descr[i] == 0)
#line 35
		break;
#line 35
	    }
#line 35
	}
#line 35
      printf ("%*.*s\n", s, s, descr);
#line 35
      descr += s;
#line 35
      if (*descr)
#line 35
	{
#line 35
	  indent (0, lmargin);
#line 35
	  descr++;
#line 35
	}
#line 35
    }
#line 35
}
#line 35

#line 35
void
#line 35
print_help(void)
#line 35
{
#line 35
  unsigned i;
#line 35
  
#line 35
  printf ("%s %s [%s]... %s\n", _("Usage:"), "grot", _("OPTION"),
#line 35
	  gettext (args_doc)); 
#line 35
  if (doc && doc[0])
#line 35
    print_option_descr(gettext (doc), 0, RMARGIN);
#line 35
  putchar ('\n');
#line 35

#line 35
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 35
    {
#line 35
      unsigned n;
#line 35
      if (opthelp[i].opt)
#line 35
	{
#line 35
	  n = printf ("  %s", opthelp[i].opt);
#line 35
	  if (opthelp[i].arg)
#line 35
	    {
#line 35
	      char *cb, *ce, *sep = "";
#line 35
	      if (opthelp[i].is_optional)
#line 35
		{
#line 35
		  cb = "[";
#line 35
		  ce = "]";
#line 35
		}
#line 35
	      else
#line 35
		cb = ce = "";
#line 35

#line 35
              if (strlen (opthelp[i].opt) == 2)
#line 35
                {
#line 35
                  if (!opthelp[i].is_optional)
#line 35
                    sep = " ";
#line 35
                }
#line 35
              else
#line 35
                sep = "=";
#line 35
	      n += printf ("%s%s%s%s", cb, sep, gettext (opthelp[i].arg), ce);
#line 35
	    }
#line 35
	  if (n >= DESCRCOLUMN)
#line 35
	    {
#line 35
	      putchar ('\n');
#line 35
	      n = 0;
#line 35
	    }
#line 35
	  indent (n, DESCRCOLUMN);
#line 35
	  print_option_descr (gettext (opthelp[i].descr), DESCRCOLUMN, RMARGIN);
#line 35
	}
#line 35
      else
#line 35
	{
#line 35
	  if (i)
#line 35
	    putchar ('\n');
#line 35
	  indent (0, GROUPCOLUMN);
#line 35
	  print_option_descr (gettext (opthelp[i].descr),
#line 35
			      GROUPCOLUMN, RMARGIN);
#line 35
	  putchar ('\n');
#line 35
	}
#line 35
    }
#line 35
  
#line 35
  putchar ('\n');
#line 35
  print_option_descr (_("Mandatory or optional arguments to long options are also mandatory or optional for any corresponding short options."), 0, RMARGIN);
#line 35
  putchar ('\n');
#line 35
  printf (_("Report bugs to %s.\n"), program_bug_address);
#line 35
}
#line 35

#line 35
void
#line 35
print_usage(void)
#line 35
{
#line 35
  unsigned i;
#line 35
  int f = 0;
#line 35
  unsigned n;
#line 35
  char buf[RMARGIN+1];
#line 35

#line 35
#define FLUSH                        do                                   {                              	  buf[n] = 0;              	  printf ("%s\n", buf);    	  n = USAGECOLUMN;         	  memset (buf, ' ', n);        }                                while (0)
#line 35
#define ADDC(c)   do { if (n == RMARGIN) FLUSH; buf[n++] = c; } while (0)
#line 35

#line 35
  n = snprintf (buf, sizeof buf, "%s %s ", _("Usage:"), "grot");
#line 35

#line 35
  /* Print a list of short options without arguments. */
#line 35
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 35
    {
#line 35
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 35
	  && opthelp[i].arg == NULL)
#line 35
	{
#line 35
	  if (f == 0)
#line 35
	    {
#line 35
	      ADDC('[');
#line 35
	      ADDC('-');
#line 35
	      f = 1;
#line 35
	    }
#line 35
	  ADDC(opthelp[i].opt[1]);
#line 35
	}
#line 35
    }
#line 35
  if (f)
#line 35
    ADDC(']');
#line 35

#line 35
  /* Print a list of short options with arguments. */
#line 35
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 35
    {
#line 35
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 35
	  && opthelp[i].arg)
#line 35
	{
#line 35
	  size_t len = 5 
#line 35
	                + strlen (opthelp[i].arg)
#line 35
			   + (opthelp[i].is_optional ? 2 : 1);
#line 35
	  if (n + len > RMARGIN) FLUSH;
#line 35
	  buf[n++] = ' '; 
#line 35
	  buf[n++] = '['; 
#line 35
	  buf[n++] = '-';
#line 35
	  buf[n++] = opthelp[i].opt[1];
#line 35
	  if (opthelp[i].is_optional)
#line 35
	    {
#line 35
	      buf[n++] = '[';
#line 35
	      strcpy (&buf[n], opthelp[i].arg);
#line 35
	      n += strlen (opthelp[i].arg);
#line 35
	      buf[n++] = ']';
#line 35
	    }
#line 35
	  else
#line 35
	    {
#line 35
	      buf[n++] = ' ';
#line 35
	      strcpy (&buf[n], opthelp[i].arg);
#line 35
	      n += strlen (opthelp[i].arg);
#line 35
	    }
#line 35
	  buf[n++] = ']';
#line 35
	}
#line 35
    }
#line 35

#line 35
  /* Print a list of long options */
#line 35
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 35
    {
#line 35
      if (opthelp[i].opt && opthelp[i].descr)
#line 35
	{
#line 35
	  size_t len;
#line 35
	  const char *longopt;
#line 35

#line 35
	  if (opthelp[i].opt[1] == '-')
#line 35
	    longopt = opthelp[i].opt;
#line 35
	  else if (opthelp[i].opt[2] == ',')
#line 35
	    longopt = opthelp[i].opt + 4;
#line 35
	  else
#line 35
	    continue;
#line 35

#line 35
	  len = 3 + strlen (longopt)
#line 35
	          + (opthelp[i].arg ? 1 + strlen (opthelp[i].arg)
#line 35
		      + (opthelp[i].is_optional ? 2 : 0) : 0);
#line 35
	  if (n + len > RMARGIN) FLUSH;
#line 35
	  buf[n++] = ' '; 
#line 35
	  buf[n++] = '['; 
#line 35
	  strcpy (&buf[n], longopt);
#line 35
	  n += strlen (longopt);
#line 35
	  if (opthelp[i].arg)
#line 35
	    {
#line 35
	      buf[n++] = '=';
#line 35
	      if (opthelp[i].is_optional)
#line 35
		{
#line 35
		  buf[n++] = '[';
#line 35
		  strcpy (&buf[n], opthelp[i].arg);
#line 35
		  n += strlen (opthelp[i].arg);
#line 35
		  buf[n++] = ']';
#line 35
		}
#line 35
	      else
#line 35
		{
#line 35
		  strcpy (&buf[n], opthelp[i].arg);
#line 35
		  n += strlen (opthelp[i].arg);
#line 35
		}
#line 35
	    }
#line 35
	  buf[n++] = ']';
#line 35
	}
#line 35
    }
#line 35
  FLUSH;
#line 35
  
#line 35
}
#line 35

#line 35
const char version_etc_copyright[] =
#line 35
  /* Do *not* mark this string for translation.  %s is a copyright
     symbol suitable for this locale, and %d is the copyright
     year.  */
#line 35
  "Copyright %s 2009 Sergey Poznyakoff";
#line 35

#line 35
void
#line 35
print_version_only(const char *program_version, FILE *stream)
#line 35
{
#line 35
	fprintf (stream, "%s\n", program_version);
#line 35
	/* TRANSLATORS: Translate "(C)" to the copyright symbol
	   (C-in-a-circle), if this symbol is available in the user's
	   locale.  Otherwise, do not translate "(C)"; leave it as-is.  */
#line 35
	fprintf (stream, version_etc_copyright, _("(C)"));
#line 35
	fputc ('\n', stream);
#line 35
}
#line 35

#line 35
void
#line 35
print_version(const char *program_version, FILE *stream)
#line 35
{
#line 35
	print_version_only(program_version, stream);
#line 35
	
#line 35
	fputs (_("License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>\nThis is free software: you are free to change and redistribute it.\nThere is NO WARRANTY, to the extent permitted by law.\n\n"),
#line 35
	       stream);
#line 35
	
#line 35
}
#line 35

#line 101 "cmdline.opt"

#line 101


void
read_options(int argc, char *argv[])
{
    
#line 106
 {
#line 106
  int c;
#line 106

#line 106
  while ((c = getopt_long(argc, argv, 
#line 106
"H::"
#line 106
"p::"
#line 106
"P:"
#line 106
"S:"
#line 106
"u:"
#line 106
"v"
#line 106
"n"
#line 106
"k:"
#line 106
"h",
#line 106
                          long_options, NULL)) != EOF)
#line 106
    {
#line 106
      switch (c)
#line 106
        {
#line 106
        default:
#line 106
	exit(1);
#line 106
       
#line 106
	#line 40 "cmdline.opt"

#line 40
	 case 'H':
#line 40
          {
#line 40

	grot_host = optarg;

#line 42
             break;
#line 42
          }
#line 46 "cmdline.opt"

#line 46
	 case 'p':
#line 46
          {
#line 46

	grot_password = optarg;
	password_option = 1;

#line 49
             break;
#line 49
          }
#line 53 "cmdline.opt"

#line 53
	 case 'P':
#line 53
          {
#line 53

	char *p;
	grot_port = strtoul(optarg, &p, 10);
	if (!grot_port || *p)
	    terror(1, NULL, "invalid port number: %s", optarg);

#line 58
             break;
#line 58
          }
#line 62 "cmdline.opt"

#line 62
	 case 'S':
#line 62
          {
#line 62

	grot_socket = optarg;

#line 64
             break;
#line 64
          }
#line 69 "cmdline.opt"

#line 69
	 case 'u':
#line 69
          {
#line 69

	grot_user = optarg;

#line 71
             break;
#line 71
          }
#line 75 "cmdline.opt"

#line 75
	 case 'v':
#line 75
          {
#line 75

	verbose++;

#line 77
             break;
#line 77
          }
#line 81 "cmdline.opt"

#line 81
	 case 'n':
#line 81
          {
#line 81

	dry_run_option = 1;
	verbose++;

#line 84
             break;
#line 84
          }
#line 88 "cmdline.opt"

#line 88
	 case OPTION_NO_FLUSH:
#line 88
          {
#line 88

	flush_logs_option = 0;

#line 90
             break;
#line 90
          }
#line 94 "cmdline.opt"

#line 94
	 case 'k':
#line 94
          {
#line 94

	char *p;	
	keep_count = strtoul(optarg, &p, 0);
	if (*p)
		terror(1, NULL, "invalid number: %s", optarg);

#line 99
             break;
#line 99
          }
#line 101 "cmdline.opt"

#line 101
	 case 'h':
#line 101
          {
#line 101

#line 101
		print_help ();
#line 101
                exit (0);
#line 101
	 
#line 101
             break;
#line 101
          }
#line 101 "cmdline.opt"

#line 101
	 case OPTION_USAGE:
#line 101
          {
#line 101

#line 101
		print_usage ();
#line 101
		exit (0);
#line 101
	 
#line 101
             break;
#line 101
          }
#line 101 "cmdline.opt"

#line 101
	 case OPTION_VERSION:
#line 101
          {
#line 101

#line 101
		/* Give version */
#line 101
		print_version(program_version, stdout);
#line 101
		exit (0);
#line 101
         
#line 101
             break;
#line 101
          }

#line 106 "cmdline.opt"
        }
#line 106
    }
#line 106
 }   
#line 106

}

